%выбор метода
% 1 - разработанный алгоритм
% 2 - циклический взвешенный
method = 1;


time = 1000;
time_plot=1:1:time;
dropped=zeros(time);

K=zeros(time);

band = [0.064 1 4]; %%% предельные значения пропускных способностей для разных типов трафика
delays = [400 1000 1000]; %%% предельные значения задержек для разных типов трафика

trigger=1;


channels = zeros(3, 2); % 1. пропускная способность максимальная, 2. задержка, 3. текущая загрузка 
channels_history=zeros(time, 2);

%задаём параметры каналов
channels(1, 1) = 12;
channels(2, 1) = 0.6;

channels(1, 2) = 6;
channels(2, 2) = 0.2;


current_sessions = zeros(4,time); % 1. тип трафика, 2. время, 3. полоса, 4. номер канала
num_sessions=0;

tr=traffic_generator(time);
channels_delays = channel_generator(time);

for i=1:time
            
    for j=1:num_sessions
        
        current_sessions(4, j);
        
        
        channels(3, current_sessions(4, j)) = channels(3, current_sessions(4, j))+current_sessions(3, j);
        if (channels(3, current_sessions(4, j))>channels(1, current_sessions(4, j)))
            dropped(i)=dropped(i)+channels(3, current_sessions(4, j))-channels(1, current_sessions(4, j));
            channels(3, current_sessions(4, j))=channels(1, current_sessions(4, j));
        end

        channels(3, current_sessions(4, j));
    end

  
    channels_history(i, 1)=channels(3, 1);
    channels_history(i, 2)=channels(3, 2);
    channels(3, 1) = 0;
    channels(3, 2) = 0;
    
    
    for j=1:num_sessions
        current_sessions(2, j) = current_sessions(2, j)-1;
        if (current_sessions(2, j)<=0)
            current_sessions(:, j)=[];
            num_sessions = num_sessions - 1;
        end
        
        switch current_sessions(1, j)
            case 1 
                u = voip_utility(channels(1, current_sessions(4, j))-channels(3, current_sessions(4, j)), band(1))*(1-iptv_utility(channels_delays(current_sessions(4, j), i), delays(1), 0.02));
           
            case 2 
                u = iptv_utility(channels(1, current_sessions(4, j))-channels(3, current_sessions(4, j)), band(2), 0.01)*(1-iptv_utility(channels_delays(current_sessions(4, j), i), delays(2), 0.02));
            case 3 
                u = ft_utility(channels(1, current_sessions(4, j))-channels(3, current_sessions(4, j)), band(3));
            otherwise
                u=0;
        end
        K(i) = K(i) + u;
        
    end
    
    
    
    if (tr(1,i)~=4)
            num_sessions=num_sessions+1;
            current_sessions(1, num_sessions)=tr(1,i);
            current_sessions(2, num_sessions)=tr(2,i);
            current_sessions(3, num_sessions)=band(tr(1,i));
            
          switch method
             
              %criterion
              case 1
            switch current_sessions(1, num_sessions)
            case 1 
                u1 = voip_utility(channels(1, 1)-channels(3, 1), band(1))*(1-iptv_utility(channels_delays(1, i), delays(1), 0.02));
                u2 = voip_utility(channels(1, 2)-channels(3, 2), band(1))*(1-iptv_utility(channels_delays(2, i), delays(1), 0.02));
            case 2 
                u1 = iptv_utility(channels(1, 1)-channels(3, 1), band(2), 0.01)*(1-iptv_utility(channels_delays(1, i), delays(2), 0.02));
                u2 = iptv_utility(channels(1, 2)-channels(3, 2), band(2), 0.01)*(1-iptv_utility(channels_delays(2, i), delays(2), 0.02));
            case 3 
                u1 = ft_utility(channels(1, 1)-channels(3, 1), band(3));
                u2 = ft_utility(channels(1, 2)-channels(3, 2), band(3));
            otherwise
                u=0;
            end
            
        if(u1>u2) 
            trigger=1;
        else
            trigger=2;
        end
            
        current_sessions(4, num_sessions)=trigger;
        
        
        %round drop
              case 2        
        
                    if(trigger==1)
                        trigger=2;
                    elseif(trigger==2)
                        trigger=3;
                    else
                        trigger=1;
                    end
                    if(trigger==3)
                    current_sessions(4, num_sessions)=2;
                    else
                    current_sessions(4, num_sessions)=1;
                    end
          end
        
    end
    
  
end

s=sum(dropped);
s(1)

s1=sum(K);
s1(1)

figure(1);
plot(time_plot, channels_history(:,1), 'g', time_plot, channels_history(:,2), 'b', time_plot, dropped, 'r');